> ## Documentation Index
> Fetch the complete documentation index at: https://docs.activeviam.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Upload borrow curves



## OpenAPI

````yaml /risk-and-pricing/atoti-risk-services/apis-endpoints/openapi/openapi.mintlify.json post /api/MarketData/UploadBorrowCurves
openapi: 3.0.1
info:
  title: Derivitec Api 1.0
  version: '1.0'
servers:
  - description: Derivitec Server
    url: https://api.riskportal.activeviam.com
security:
  - oauth2: []
  - apikey: []
paths:
  /api/MarketData/UploadBorrowCurves:
    post:
      tags:
        - MarketData
      summary: Upload borrow curves
      operationId: UploadBorrowCurves
      requestBody:
        content:
          application/json-patch+json:
            schema:
              $ref: '#/components/schemas/ApiUploadBorrowCurvesRequest'
          application/json:
            schema:
              $ref: '#/components/schemas/ApiUploadBorrowCurvesRequest'
          text/json:
            schema:
              $ref: '#/components/schemas/ApiUploadBorrowCurvesRequest'
          application/*+json:
            schema:
              $ref: '#/components/schemas/ApiUploadBorrowCurvesRequest'
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiUploadBorrowCurvesResponse'
          description: Success
        '400':
          description: BadRequest
        '401':
          description: Unauthorized
        '403':
          description: Forbidden
      security:
        - oauth2: []
        - apikey: []
components:
  schemas:
    ApiUploadBorrowCurvesRequest:
      example:
        use_best_effort: true
        upload_zero_rates: true
        market_date: '2000-01-23T04:56:07.000+00:00'
        borrow_rates_by_identifiers:
          - value:
              - value: 3.5571952270680973
                key: key
              - value: 3.5571952270680973
                key: key
            key:
              code: code
              market_identification_code: market_identification_code
              identifier_type: Derivitec
          - value:
              - value: 3.5571952270680973
                key: key
              - value: 3.5571952270680973
                key: key
            key:
              code: code
              market_identification_code: market_identification_code
              identifier_type: Derivitec
      properties:
        market_data_environment_name:
          nullable: true
          type: string
        provider_id:
          nullable: true
          type: string
        borrow_rates_by_identifiers:
          items:
            $ref: >-
              #/components/schemas/InstrumentIdentifierStringDoubleKeyValuePairListKeyValuePair
          nullable: true
          type: array
        market_date:
          format: date-time
          type: string
        use_best_effort:
          type: boolean
        upload_zero_rates:
          type: boolean
        $type:
          type: string
          enum:
            - >-
              Derivitec.Web.Core.MarketData.ApiUploadBorrowCurvesRequest,
              Derivitec.Web.Core
      required:
        - $type
      type: object
    ApiUploadBorrowCurvesResponse:
      required:
        - $type
      type: object
      properties:
        is_success:
          type: boolean
        error_messages:
          items:
            type: string
          nullable: true
          type: array
        $type:
          type: string
          enum:
            - >-
              Derivitec.Web.Core.MarketData.ApiUploadBorrowCurvesResponse,
              Derivitec.Web.Core
    InstrumentIdentifierStringDoubleKeyValuePairListKeyValuePair:
      example:
        value:
          - value: 3.5571952270680973
            key: key
          - value: 3.5571952270680973
            key: key
        key:
          code: code
          market_identification_code: market_identification_code
          identifier_type: Derivitec
      properties:
        key:
          $ref: '#/components/schemas/InstrumentIdentifier'
        value:
          items:
            $ref: '#/components/schemas/StringDoubleKeyValuePair'
          nullable: true
          type: array
      type: object
    InstrumentIdentifier:
      example:
        code: code
        market_identification_code: market_identification_code
        identifier_type: Derivitec
      properties:
        code:
          nullable: true
          type: string
        identifier_type:
          enum:
            - Derivitec
            - Ric
            - Bloomberg
            - Isin
            - Figi
            - Sedol
            - RedCode
            - RedPairCode
            - BloombergYellow
            - XIgniteCode
            - CBondsId
            - EdiSecId
            - EdiSymbol
            - NotSet
          type: string
        market_identification_code:
          nullable: true
          type: string
        $type:
          type: string
          enum:
            - >-
              Derivitec.Web.Core.MarketData.InstrumentIdentifier,
              Derivitec.Web.Core
      required:
        - $type
      type: object
    StringDoubleKeyValuePair:
      example:
        value: 3.5571952270680973
        key: key
      properties:
        key:
          nullable: true
          type: string
        value:
          format: double
          type: number
      type: object
  securitySchemes:
    oauth2:
      description: >-
        OAuth2 access-token requested from AWS Cognito and provided as a Auth
        Bearer header
      flows:
        implicit:
          authorizationUrl: https://auth.riskportal.derivitec.com/oauth2/authorize
          scopes: {}
      type: oauth2
    apikey:
      description: API-Key requested via the site and provided as a header
      in: header
      name: x-api-key
      type: apiKey

````